require 'graal/tree'
require 'graal/blob'
require 'graal/actor'

module Graal

   class Commit < Tree

      def initialize(backend, revision)
         super(backend, revision, '')
      end

      def parent
         Commit.new(@backend, info[0])
      end

      def author
         @author ||= Actor.new(info[1], info[2])
      end

      def author_date
         @author_date ||= Time.at(info[3].to_i)
      end

      def committer
         @committer ||= Actor.new(info[4], info[5])
      end

      def committer_date
         @committer_date ||= Time.at(info[6].to_i)
      end

      def subject
         @subject ||= info[7]
      end

      def body
         @body ||= info.length > 8 ? info[8] : ''
      end

   private

      def info
         @info ||= @backend.commit_info(@revision)
      end
   end
end
