module Graal::Backend::Exe

   class Git

      def heads
         refs('heads')
      end

      def tags
         refs('tags')
      end

   private

      def git_directory
         live = File.join(@repository, '.git')
         return live if File.exists? live
         return @repository
      end

      def refs(type)
         refs = []
         git_dir = git_directory

         refs_dir = File.join(git_dir, 'refs', type)
         if File.exists? refs_dir
            Dir.chdir refs_dir do
               Dir['*'].each { |ref| refs << ref if File.file?(ref) }
            end
         end

         packed = File.join(git_dir, 'packed-refs')
         if File.exists? packed
            pattern  = %r{ refs/#{type}/(.+)$}
            File.read(packed).scan(pattern).each { |m| refs << m.first }
         end

         refs
      end
   end
end
