require 'graal/commit'

module Graal

   class Repository < Commit

      attr_reader :directory

      def initialize(repository_path)
         backend = Backend.create repository_path
         super(backend, 'HEAD')
         @directory = repository_path
      end

      def heads
         @backend.heads
      end
      alias branches heads

      def tags
         @backend.tags
      end

      def commit(name)
         Commit.new(@backend, name)
      end
      alias revision commit
      alias rev      commit

      def master
         rev('master')
      end
   end
end
